/*
 * $Header: /home/puhuri/Tutkimus/src/timer/RCS/sched_tst.c,v 1.4 1997/02/27 13:21:34 puhuri Exp puhuri $
 *
 * $Log: sched_tst.c,v $
 * Revision 1.4  1997/02/27 13:21:34  puhuri
 * Toimii solariksessa.
 * Muutettu mittaus aikapohjaiseksi.
 * Prosessien kynnistyksen jrjestyksen muuttaminen.
 *
 * Revision 1.3  1997/02/19 12:47:07  puhuri
 * Ekojen mittausten versio.
 *
 * Revision 1.2  1996/11/22 08:27:18  puhuri
 * Muutettu rakenne kyttmn conf-rakennetta.
 * Lapsiprosessien ksittely.
 *
 * Revision 1.1  1996/11/19 15:59:41  puhuri
 * Initial revision
 *
 *
 *
 */
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#ifdef linux			/* linux */
#include <linux/a.out.h>
#elif defined sun
#include <sys/param.h>		/* sun */
#define PAGE_SIZE PAGESIZE
#endif
#include <sys/wait.h>
#include <errno.h>
#include "sched_tst.h"

#ifdef RCS_INFO
static char rcs_id[] = "$Id: sched_tst.c,v 1.4 1997/02/27 13:21:34 puhuri Exp puhuri $";
#endif

static void count_childs (int sig);
static void start_remote (struct conf_info *conf, char *progname);
static void remove_child_pid (struct conf_info *conf, pid_t pid);

struct conf_info conf;
/*
 * Prutiini.  Ottaa argumentteina seuraavat:
 * <procs> <loops> <dloops> <usleep> <ofile_fmt>
 * -n X : tyhjnpyrijien mr 
 * -l X : montako kertaa kysytn aikaa
 * -d X : paljonko tehdn vlityt
 * -s X : kuinka kauan odotetaan ennen tulosten tulostusta (usec)
 * -o X : tiedoston nimi: sprintf argumenttina tyyppi-merkki, numero
 *        't' - tyhj, 's' - lhettv, 'r' - vastaanottaja
 * -h X : nielukone
 * -r X : lukukoko (verkosta)
 * -w X : kirjoituskoko (verkkoon) lukukoko (levylt)
 * -t X : montako kirjoituskertaa
 * -m X : montako kirjoitusprosessia
 * -R   : vastaanottava prosessi
 */
#define OPTSTRING "RT:z:i:m:t:w:r:h:o:s:d:l:n:"

int main(int argc, char **argv)
{
  char pbuf[PORT_SIZE + 1 + 1];
  extern char *optarg;
  int option;
  int i;
  pid_t child;
  int child_exit_status;

  bzero (&conf, sizeof(conf));	/* alustetaan nollaksi */
  conf.tom = 2000 * 1000;	/* T: mittausaika */
  conf.tprogs = 1;		/* n: tyhjnpyrijien mr */
  conf.tloops = 1;		/* l: tyhjnpyrijien kierrokset */
  conf.data_size = 1000;	/* d: tyhjnpyrijien viive kierrokset */
  conf.usleep_start = 1000 * 1000; /* s: kauanko odotetaan ennen tallennusta */
  conf.usleep_start_str = "1000";
				/* s: kauanko odotetaan ennen tallennusta */
  conf.ofile_fmt = "out.%c.%d"; /* o: tulostustiedoston muoto */
  conf.host = "localhost";	/* h: etkone */
  conf.current_dir = NULL;	/* c: hakemisto etkoneessa */
  conf.read_size = 1460;	/* r: lukukoko (verkosta) */
  conf.read_size_str = "1460";	/* r: lukukoko (verkosta) */
  conf.write_size = 1460;	/* w: kirjoituskoko (verkkoon) */
  conf.write_times = 1;		/* t: kirjoituskerrat */
  conf.write_times_str = "1";	/* t: kirjoituskerrat */
  conf.wprogs = 1;		/* m: kirjoittajien mr */
  conf.in_file = argv[0];	/* i: tiedosto, jota luetaan */
  conf.usleep_end = 2000000;	/* z: kauanko odotetaan ennen tulostusta */
  conf.usleep_end_str = "2000";
				/* z: kauanko odotetaan ennen tulostusta */
  conf.readerp = 0;		/* R ollaako vastaanottava */

  while ((option = getopt (argc, argv, OPTSTRING)) != -1) {
    switch (option) {
    case 'T':
      conf.tom = atoi(optarg) * 1000;
				/* ei tarvetta argumentiksi etlle */
      break;
    case 'R':
      conf.readerp = 1;
      break;
    case 'z':
      conf.usleep_end = atoi(optarg) * 1000;
      conf.usleep_end_str = optarg;
      break;
    case 'i':
      conf.in_file = optarg;
      break;
    case 'm':
      conf.wprogs = atoi (optarg);
      break;
    case 't':
      conf.write_times = atoi (optarg);
      conf.write_times_str = optarg;
      break;
    case 'w':
      conf.write_size = atoi (optarg);
      break;
    case 'r':
      conf.read_size = atoi (optarg);
      conf.read_size_str = optarg;
      break;
    case 'h':
      conf.host = optarg;
      break;
    case 'o':
      conf.ofile_fmt = optarg;
      break;
    case 's':
      conf.usleep_start = atoi (optarg) * 1000;
      conf.usleep_start_str = optarg;
      break;
    case 'd':
      conf.data_size = atoi (optarg);
      break;
    case 'l':
      conf.tloops = atoi (optarg);
      break;
    case 'n':
      conf.tprogs = atoi (optarg);
      break;
    case '?':
    case ':':
      fprintf (stderr, "Usage: %s\n", OPTSTRING);
      exit (ERR_BAD_USAGE);
      break;
    }
  }

  conf.child_table_size = (conf.readerp) ? 
    (conf.wprogs) :		/* nielulla wprogs-mr */
    (conf.tprogs + conf.wprogs + 1) /* t + w + nieluprosessin kynnistys  */
    + 1;			/* varalta yksi */

  if ((conf.child_table = calloc (conf.child_table_size, sizeof (pid_t))) 
      == NULL) {
    PERROR ("malloc: ", ERR_NO_MEMORY);
  }

  if (gettimeofday (&(conf.start_time), NULL) < 0) {
    PERROR ("gettimeofday: ", ERR_GETTIMEOFDAY);
  }
  conf.go_time = add_time (conf.start_time, conf.usleep_start);
  conf.stop_time = add_time (conf.start_time, conf.tom + conf.usleep_start);
  
  if (conf.readerp) {		/* ollaan nielu, eli kynnistytn */
    DPRINTF ("Reader: %d", getpid());
    sink (&conf);
  } else {			/* ollaan pprosessi */
    signal (SIGUSR1, count_childs);
    if (setpgid (0, 0) < 0)
      PERROR ("setpgrp:", ERR_SETPGID);
    DPRINTF ("Starting remote: %d", getpid());
    start_remote (&conf, argv[0]);
    DPRINTF ("Remote started: %d (%d)", conf.child_table[0], getpid());

    while (read (conf.fd_from_remote, pbuf, PORT_SIZE + 1) < 0) {
      if (errno != EINTR)	/* jos saadaan signaali */
	PERROR ("read", ERR_PIPEREAD);
    }
    /* otetaan selville portti */
    conf.port = atoi (pbuf);
    DPRINTF ("Remote port: %d (%s)", conf.port, pbuf);

    sync_time_server (&conf);
				/* lazy max... */
    for (i = 0; i < conf.tprogs + conf.wprogs; i++) {
      if (i < conf.tprogs)
	noworker (&conf);
      if (i < conf.wprogs)
	sender (&conf);		/* lhettjt ja tyhjntoimittajat */
    }

    while (conf.childs_running) {
      DPRINTF ("Waiting everybody to start: %d not ready\n",
	       conf.childs_running);
      if ((child = wait (&child_exit_status)) > 0) {
	conf.childs_running--;
	decode_wait (child, child_exit_status);
      }
    }
    DPRINTF ("All running! (%d)", getpid());
    if (kill(-getpgid(0), SIGUSR1) < 0)
      PERROR ("kill", ERR_KILL);

    write (conf.fd_to_remote, "x", 1);
    for (;;) {
      child = wait (&child_exit_status);
      if (decode_wait (child, child_exit_status) == OK)
	break;
    }
  }
  exit (OK);
}

int decode_wait (pid_t child, int child_exit_status)
{
  char hostname[BUF_SIZE] = "unknown";

  switch (child) {
  case -1: 
    if (errno != ECHILD)
      PERROR ("wait: ", ERR_WAIT);
  case 0:
    gethostname (hostname, BUF_SIZE);
    fprintf (stderr, "%s:%d: No childs available\n", hostname, getpid());
    return (OK);
    break;
  default:
    gethostname (hostname, BUF_SIZE);
    fprintf (stderr, "%s:%d: Child %d ", hostname, getpid(), child);
    if (WIFEXITED (child_exit_status)) { /* exited normaly */
      fprintf (stderr, "exited %snormaly with code %d\n",
	       (WEXITSTATUS (child_exit_status))?"ab":"",
	       WEXITSTATUS (child_exit_status));
    } else if (WIFSIGNALED (child_exit_status)) {
      fprintf (stderr, "exited with signal %d\n",
	       WTERMSIG (child_exit_status));
    } else if (WIFSTOPPED (child_exit_status)) {
      fprintf (stderr, "stopped with signal %d\n",
	       WSTOPSIG (child_exit_status));
    } else {
      fprintf (stderr, "exited. Status word %d\n",
	       child_exit_status);
    }
    remove_child_pid (&conf, child);
    break;
  }
  return !OK;
}

void *get_dirty_mem (size_t bytes)
{
  void *mem;
  char *p, *himem;
  
  if ((mem = malloc (bytes)) == NULL) {
    PERROR ("malloc: ", ERR_NOEXIT);
    return NULL;
  }

  for (himem = mem + bytes, p = mem + PAGE_SIZE / 2;
       p < himem; p += PAGE_SIZE) {
    *p = (char)0;		/* kosketellaan muistia, joka sivulta */
  }

  return mem;
}

static void count_childs (int sig)
{
  conf.childs_running--;
  signal (SIGUSR1, count_childs);
}


void child_wait_sig (int sig)
{
  conf.wait_for_signal = 0;
  signal (SIGUSR1, SIG_DFL);	/* reset to default */
}

static void start_remote(struct conf_info *conf, char *progname)
{
  int fd_to_remote[2];		/* putki etlle */
  int fd_from_remote[2];	/* putki etlt */
  
  /* 
   * Luodaan putket liikennintiin etprosessin kanssa.
   */
  if (pipe(fd_to_remote) != 0) {
    PERROR ("pipe: ", ERR_PIPEOPEN);
  }
  if (pipe(fd_from_remote) != 0) {
    PERROR("pipe: ", ERR_PIPEOPEN);
  }
    
  if ((conf->child_table[0] = fork()) == 0) { /* ollaan lapsiprosessi */
    char rem_cmd[BUF_SIZE];
    char cwd[BUF_SIZE];
    
    dup2 (fd_to_remote[0], STDIN_FILENO); /* muutetaan stdin putkeen */
    dup2 (fd_from_remote[1], STDOUT_FILENO); /* muutetaan stdout putkeen */
    
    if (setpgid (getpid(), getpid()) < 0) {
      PERROR ("setpgid: ", ERR_NOEXIT);
      /* ei tarvetta poistua */
    }
    
    signal (SIGUSR1, SIG_IGN); /* ei vlitet USR1-signaalista
				* (kaiken varalta)
				*/

    if (conf->current_dir == NULL) {
      if (getcwd (cwd, BUF_SIZE) == NULL) {
	PERROR ("getcwd: ", ERR_BAD_DIRECTORY);
      }
      if ((conf->current_dir = strdup (cwd)) == NULL) {
	PERROR ("strdup: ", ERR_NO_MEMORY);
      }
    }
    sprintf (rem_cmd, "%s/%s", conf->current_dir, progname);

    DPRINTF ("About to exec: %d", getpid());
    
    execlp (REMOTE_SHELL, REMOTE_SHELL, 
	    conf->host, "-x", 
	    "cd", conf->current_dir, ";",
	    rem_cmd, "-R",
	    "-r", conf->read_size_str,
	    "-t", conf->write_times_str,
	    "-o", conf->ofile_fmt,
	    "-s", conf->usleep_start_str,
	    "-z", conf->usleep_end_str,
	    NULL);
    /* Jos tnne tullaan, homma on heikosti */
    PERROR ("execlp: ", ERR_EXEC);
  }       
  conf->fd_to_remote = fd_to_remote[1];
  conf->fd_from_remote = fd_from_remote[0];
}

void add_child_pid (struct conf_info *conf, pid_t pid)
{
  static int next_free = 0;	/* optimoidaan */
  int i;

  for (i = next_free; i < conf->child_table_size; i++) {
    if (conf->child_table[i] == 0) {
      conf->child_table[i] = pid;
      next_free = i + 1;
      DPRINTF ("Inserted pid %d to entry %d (%d)", pid, i, getpid());
      return;
    }
  }
  if (next_free > 0) {
    next_free = 0;		/* katsotaan, josko olisi jossain tilaa */
    add_child_pid ( conf, pid);	/* ja yritetn uudestaan */
  }
  return;
}

static void remove_child_pid (struct conf_info *conf, pid_t pid)
{
  int i;

  for (i = 0; i < conf->child_table_size; i++) {
    if (conf->child_table[i] == pid) {
      fprintf (stderr, "%d: %d == %d\n", getpid(), pid, i);
      conf->child_table[i] = 0;
      return;
    }
  }
  fprintf (stderr, "Process %d claimed to be my child!\n", pid);
  return;
}

struct timeval add_time (struct timeval tv, int usec)
{
  tv.tv_usec += usec % i10E6;
  tv.tv_sec += usec / i10E6;
  /*
   * Normalisoidaan
   */
  while (tv.tv_usec > i10E6) {
    tv.tv_usec -= i10E6;
    tv.tv_sec++;
  }
  while (tv.tv_usec > i10E6) {
    tv.tv_usec += i10E6;
    tv.tv_sec--;
  }
  return tv;
}
